# Images optimisées

Images optimisées se propose de réduire la taille des images lors de leur téléversement.

## Dépendances

Le plugin Images optimisées s'appuie sur le [package _image-optimizer_ de Spatie](https://github.com/spatie/image-optimizer) qui fait appel lui-même à différents utilitaires de traitement des images :

- jpegoptim
- optipng
- pngquant
- svgo
- gifsicle
- cwebp

En l'état, le plugin ne gère que les images jpg, png et gif.

## Installation sous Windows

Les binaires sont à mettre dans le dossier System32 de Windows (testé avec Laragon 5) :
- jpegoptim : https://github.com/XhmikosR/jpegoptim-windows/releases
- optipng : http://optipng.sourceforge.net/
- pngquant : https://pngquant.org/ (binary for Windows)
- gifsicle : https://eternallybored.org/misc/gifsicle/
- cwebp : https://developers.google.com/speed/webp/download (seulement bin/cwebp)

## Fonctionnement

Sans grand mérite, on a copié le fonctionnement du plugin GIS qui associe un point GIS lors de l'upload d'une image si elle possède des données EXIF.

On s'insère dans le pipeline *post_edition* et lors de l'ajout d'un document, s'il s'agit d'une image jpg, png ou gif :

- on fait une copie de l'image que l'on suffixe avec ".back"
- on compresse l'image
- on met à jour le champ taille de la table spip_documents

## TODO

- [x] configuration : copie ? ...
- [ ] gestion des erreurs ?
- [x] effacer le fichier sauvegardé lors de la suppression du document
- [ ] ajout d'un bouton au formulaire d'édition des documents permettant de ne retenir que l'image sauvegardée comme devant être distribuée
- ...